import type { Node } from 'prosemirror-model';
import { PluginKey } from 'prosemirror-state';
import { DecorationSet } from 'prosemirror-view';
import type { ExtensionAuto } from '../../../core';
import { PlaceholderOptions } from '../../../utils/placeholder';
export declare const createPlaceholder: (node: Node, parent: Node | null, focus?: boolean) => HTMLDivElement | null;
export declare const Placeholder: ExtensionAuto<PlaceholderOptions>;
declare module 'prosemirror-model' {
    interface NodeSpec {
        placeholder?: {
            content: string | ((node: Node, parent?: Node | null) => string | null);
            customPlugin?: PluginKey<DecorationSet>;
            alwaysVisible?: boolean;
        };
    }
}
declare global {
    namespace YfmEditor {
        interface Context {
            placeholder: PlaceholderOptions;
        }
    }
}
