"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Renderer = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_use_1 = require("react-use");
exports.Renderer = (0, react_1.memo)(({ storage }) => {
    const update = (0, react_use_1.useUpdate)();
    (0, react_1.useEffect)(() => {
        storage.on('update', update);
        return () => {
            storage.off('update', update);
        };
    }, [storage, update]);
    return (react_1.default.createElement(react_1.default.Fragment, null, storage.getItems().map((item) => (react_1.default.createElement(ItemRenderer, { key: item.id, item: item })))));
});
exports.Renderer.displayName = 'ReactRenderer';
const ItemRenderer = (0, react_1.memo)(({ item }) => {
    const update = (0, react_use_1.useUpdate)();
    (0, react_1.useEffect)(() => {
        item.on('rerender', update);
        return () => {
            item.off('rerender', update);
        };
    }, [item, update]);
    return react_1.default.createElement(react_1.default.Fragment, null, item.render());
});
ItemRenderer.displayName = 'ReactItemRenderer';
