"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BehaviorPreset = void 0;
const tslib_1 = require("tslib");
const Selection_1 = require("./Selection");
const Placeholder_1 = require("./Placeholder");
const Cursor_1 = require("./Cursor");
const History_1 = require("./History");
const Clipboard_1 = require("./Clipboard");
const ReactRenderer_1 = require("./ReactRenderer");
tslib_1.__exportStar(require("./Cursor"), exports);
tslib_1.__exportStar(require("./History"), exports);
tslib_1.__exportStar(require("./Clipboard"), exports);
tslib_1.__exportStar(require("./Selection"), exports);
tslib_1.__exportStar(require("./Placeholder"), exports);
tslib_1.__exportStar(require("./ReactRenderer"), exports);
const BehaviorPreset = (builder, opts) => {
    var _a, _b, _c, _d;
    builder
        .use(Selection_1.Selection)
        .use(Placeholder_1.Placeholder, (_a = opts.placeholder) !== null && _a !== void 0 ? _a : {})
        .use(Cursor_1.Cursor, (_b = opts.cursor) !== null && _b !== void 0 ? _b : {})
        .use(History_1.History, (_c = opts.history) !== null && _c !== void 0 ? _c : {})
        .use(Clipboard_1.Clipboard, (_d = opts.clipboard) !== null && _d !== void 0 ? _d : {})
        .use(ReactRenderer_1.ReactRendererExtension, opts.reactRenderer);
};
exports.BehaviorPreset = BehaviorPreset;
