"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ItalicSpecs = exports.italicType = exports.italicMarkName = void 0;
const schema_1 = require("../../../../utils/schema");
exports.italicMarkName = 'em';
exports.italicType = (0, schema_1.markTypeFactory)(exports.italicMarkName);
const ItalicSpecs = (builder) => {
    builder.addMark(exports.italicMarkName, () => ({
        spec: {
            parseDOM: [
                { tag: 'i' },
                { tag: 'em' },
                { style: 'font-style', getAttrs: (value) => value === 'italic' && null },
            ],
            toDOM() {
                return ['em'];
            },
        },
        toYfm: { open: '*', close: '*', mixable: true, expelEnclosingWhitespace: true },
        fromYfm: { tokenSpec: { name: exports.italicMarkName, type: 'mark' } },
    }));
};
exports.ItalicSpecs = ItalicSpecs;
