"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListsSpecs = exports.olType = exports.blType = exports.liType = exports.ListNode = void 0;
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const toYfm_1 = require("./toYfm");
const spec_1 = require("./spec");
var const_2 = require("./const");
Object.defineProperty(exports, "ListNode", { enumerable: true, get: function () { return const_2.ListNode; } });
exports.liType = (0, schema_1.nodeTypeFactory)(const_1.ListNode.ListItem);
exports.blType = (0, schema_1.nodeTypeFactory)(const_1.ListNode.BulletList);
exports.olType = (0, schema_1.nodeTypeFactory)(const_1.ListNode.OrderedList);
const ListsSpecs = (builder) => {
    builder
        .addNode(const_1.ListNode.ListItem, () => ({
        spec: spec_1.spec[const_1.ListNode.ListItem],
        toYfm: toYfm_1.toYfm[const_1.ListNode.ListItem],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.ListNode.ListItem] },
    }))
        .addNode(const_1.ListNode.BulletList, () => ({
        spec: spec_1.spec[const_1.ListNode.BulletList],
        toYfm: toYfm_1.toYfm[const_1.ListNode.BulletList],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.ListNode.BulletList] },
    }))
        .addNode(const_1.ListNode.OrderedList, () => ({
        spec: spec_1.spec[const_1.ListNode.OrderedList],
        toYfm: toYfm_1.toYfm[const_1.ListNode.OrderedList],
        fromYfm: { tokenSpec: fromYfm_1.fromYfm[const_1.ListNode.OrderedList] },
    }));
};
exports.ListsSpecs = ListsSpecs;
