"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.joinPrevList = exports.liftIfCursorIsAtBeginningOfItem = exports.toList = void 0;
const prosemirror_schema_list_1 = require("prosemirror-schema-list");
const utils_1 = require("./utils");
const selection_1 = require("../../../utils/selection");
const join_1 = require("../../../commands/join");
function toList(listType) {
    return (state, dispatch) => {
        const parentList = (0, utils_1.findAnyParentList)(state.schema)(state.selection);
        if (parentList) {
            if (listType === parentList.node.type)
                return true;
            dispatch === null || dispatch === void 0 ? void 0 : dispatch(state.tr.setNodeMarkup(parentList.pos, listType));
            return true;
        }
        return (0, prosemirror_schema_list_1.wrapInList)(listType)(state, dispatch);
    };
}
exports.toList = toList;
const liftIfCursorIsAtBeginningOfItem = (state, dispatch) => {
    const $cursor = (0, selection_1.get$CursorAtBlockStart)(state.selection);
    if (!$cursor)
        return false;
    const { schema } = state;
    const parentBlock = $cursor.node($cursor.depth - 1);
    if (parentBlock.firstChild === $cursor.parent && (0, utils_1.isListItemNode)(parentBlock)) {
        return (0, prosemirror_schema_list_1.liftListItem)((0, utils_1.liType)(schema))(state, dispatch);
    }
    return false;
};
exports.liftIfCursorIsAtBeginningOfItem = liftIfCursorIsAtBeginningOfItem;
exports.joinPrevList = (0, join_1.joinPreviousBlock)({
    checkPrevNode: utils_1.isListNode,
    skipNode: utils_1.isListOrItemNode,
});
