"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Monospace = exports.monospace = exports.monospaceType = exports.monospaceMarkName = void 0;
const actions_1 = require("../../../utils/actions");
const inputrules_1 = require("../../../utils/inputrules");
const MonospaceSpecs_1 = require("./MonospaceSpecs");
var MonospaceSpecs_2 = require("./MonospaceSpecs");
Object.defineProperty(exports, "monospaceMarkName", { enumerable: true, get: function () { return MonospaceSpecs_2.monospaceMarkName; } });
Object.defineProperty(exports, "monospaceType", { enumerable: true, get: function () { return MonospaceSpecs_2.monospaceType; } });
/** @deprecated Use `monospaceMarkName` instead */
exports.monospace = MonospaceSpecs_1.monospaceMarkName;
const monoAction = 'mono';
const Monospace = (builder) => {
    builder.use(MonospaceSpecs_1.MonospaceSpecs);
    builder
        .addAction(monoAction, ({ schema }) => (0, actions_1.createToggleMarkAction)((0, MonospaceSpecs_1.monospaceType)(schema)))
        .addInputRules(({ schema }) => ({
        rules: [
            (0, inputrules_1.markInputRule)({ open: '##', close: '##', ignoreBetween: '#' }, (0, MonospaceSpecs_1.monospaceType)(schema)),
        ],
    }));
};
exports.Monospace = Monospace;
