"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmCutSpecs = exports.cutContentType = exports.cutTitleType = exports.cutType = exports.CutNode = void 0;
const tslib_1 = require("tslib");
const log_1 = tslib_1.__importDefault(require("@diplodoc/transform/lib/log"));
const cut_1 = tslib_1.__importDefault(require("@diplodoc/transform/lib/plugins/cut"));
const schema_1 = require("../../../../utils/schema");
const const_1 = require("./const");
const fromYfm_1 = require("./fromYfm");
const spec_1 = require("./spec");
const toYfm_1 = require("./toYfm");
var const_2 = require("./const");
Object.defineProperty(exports, "CutNode", { enumerable: true, get: function () { return const_2.CutNode; } });
exports.cutType = (0, schema_1.nodeTypeFactory)(const_1.CutNode.Cut);
exports.cutTitleType = (0, schema_1.nodeTypeFactory)(const_1.CutNode.CutTitle);
exports.cutContentType = (0, schema_1.nodeTypeFactory)(const_1.CutNode.CutContent);
const YfmCutSpecs = (builder, opts) => {
    const spec = (0, spec_1.getSpec)(opts, builder.context.get('placeholder'));
    builder
        .configureMd((md) => md.use(cut_1.default, { log: log_1.default }))
        .addNode(const_1.CutNode.Cut, () => ({
        spec: spec[const_1.CutNode.Cut],
        toYfm: toYfm_1.toYfm[const_1.CutNode.Cut],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.CutNode.Cut],
        },
        view: opts.cutView,
    }))
        .addNode(const_1.CutNode.CutTitle, () => ({
        spec: spec[const_1.CutNode.CutTitle],
        toYfm: toYfm_1.toYfm[const_1.CutNode.CutTitle],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.CutNode.CutTitle],
        },
        view: opts.cutTitleView,
    }))
        .addNode(const_1.CutNode.CutContent, () => ({
        spec: spec[const_1.CutNode.CutContent],
        toYfm: toYfm_1.toYfm[const_1.CutNode.CutContent],
        fromYfm: {
            tokenSpec: fromYfm_1.fromYfm[const_1.CutNode.CutContent],
        },
        view: opts.cutContentView,
    }));
};
exports.YfmCutSpecs = YfmCutSpecs;
