"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.YfmTable = exports.yfmTableCellType = exports.yfmTableRowType = exports.yfmTableBodyType = exports.yfmTableType = exports.YfmTableNode = exports.convertToYfmTable = void 0;
const prosemirror_state_1 = require("prosemirror-state");
const table_utils_1 = require("../../../table-utils");
const actions_1 = require("./actions");
const goToNextRow_1 = require("./commands/goToNextRow");
const backspace_1 = require("./commands/backspace");
const paste_1 = require("./paste");
const YfmTableSpecs_1 = require("./YfmTableSpecs");
const action = 'createYfmTable';
var convert_table_1 = require("./commands/convert-table");
Object.defineProperty(exports, "convertToYfmTable", { enumerable: true, get: function () { return convert_table_1.convertToYfmTable; } });
var YfmTableSpecs_2 = require("./YfmTableSpecs");
Object.defineProperty(exports, "YfmTableNode", { enumerable: true, get: function () { return YfmTableSpecs_2.YfmTableNode; } });
Object.defineProperty(exports, "yfmTableType", { enumerable: true, get: function () { return YfmTableSpecs_2.yfmTableType; } });
Object.defineProperty(exports, "yfmTableBodyType", { enumerable: true, get: function () { return YfmTableSpecs_2.yfmTableBodyType; } });
Object.defineProperty(exports, "yfmTableRowType", { enumerable: true, get: function () { return YfmTableSpecs_2.yfmTableRowType; } });
Object.defineProperty(exports, "yfmTableCellType", { enumerable: true, get: function () { return YfmTableSpecs_2.yfmTableCellType; } });
const YfmTable = (builder, options) => {
    builder.use(YfmTableSpecs_1.YfmTableSpecs, options);
    builder
        .addKeymap(() => ({
        Tab: (0, table_utils_1.goToNextCell)('next'),
        'Shift-Tab': (0, table_utils_1.goToNextCell)('prev'),
        ArrowDown: (0, goToNextRow_1.goToNextRow)('down'),
        ArrowUp: (0, goToNextRow_1.goToNextRow)('up'),
        Backspace: backspace_1.backspaceCommand,
    }))
        .addAction(action, () => actions_1.createYfmTable);
    builder.addPlugin(({ schema }) => new prosemirror_state_1.Plugin({
        props: {
            transformPasted(slice) {
                return (0, paste_1.fixPastedTableBodies)(slice, schema);
            },
        },
    }));
};
exports.YfmTable = YfmTable;
