"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSpec = void 0;
const const_1 = require("./const");
const DEFAULT_PLACEHOLDERS = {
    TabTitle: 'Tab title',
};
const getSpec = (opts, placeholder) => {
    var _a, _b;
    return ({
        [const_1.TabsNode.Tab]: {
            attrs: {
                [const_1.TabAttrs.id]: { default: 'unknown' },
                [const_1.TabAttrs.class]: { default: 'yfm-tab' },
                [const_1.TabAttrs.role]: { default: 'unknown' },
                [const_1.TabAttrs.ariaControls]: { default: 'unknown' },
                [const_1.TabAttrs.ariaSelected]: { default: 'unknown' },
                [const_1.TabAttrs.tabindex]: { default: 'unknown' },
                [const_1.TabAttrs.dataDiplodocKey]: { default: 'unknown' },
                [const_1.TabAttrs.dataDiplodocid]: { default: 'unknown' },
                [const_1.TabAttrs.dataDiplodocIsActive]: { default: 'unknown' },
            },
            marks: '',
            content: 'text*',
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-tab' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            placeholder: {
                content: (_b = (_a = placeholder === null || placeholder === void 0 ? void 0 : placeholder[const_1.TabsNode.Tab]) !== null && _a !== void 0 ? _a : opts === null || opts === void 0 ? void 0 : opts.tabPlaceholder) !== null && _b !== void 0 ? _b : DEFAULT_PLACEHOLDERS.TabTitle,
                alwaysVisible: true,
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
        },
        [const_1.TabsNode.TabPanel]: {
            attrs: {
                [const_1.TabPanelAttrs.id]: { default: 'unknown' },
                [const_1.TabPanelAttrs.class]: { default: 'yfm-tab-panel' },
                [const_1.TabPanelAttrs.role]: { default: 'unknown' },
                [const_1.TabPanelAttrs.dataTitle]: { default: 'unknown' },
                [const_1.TabPanelAttrs.ariaLabelledby]: { default: 'unknown' },
            },
            content: '(block | paragraph)+',
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-tab-panel' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            selectable: false,
            allowSelection: false,
            complex: 'leaf',
            isolating: true,
        },
        [const_1.TabsNode.Tabs]: {
            attrs: {
                [const_1.TabsAttrs.class]: { default: 'yfm-tabs' },
                [const_1.TabsAttrs.dataDiplodocGroup]: { default: 'unknown' },
            },
            content: `${const_1.TabsNode.TabsList} ${const_1.TabsNode.TabPanel}+`,
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-tabs' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            complex: 'root',
        },
        [const_1.TabsNode.TabsList]: {
            attrs: {
                [const_1.TabsListAttrs.class]: { default: 'yfm-tab-list' },
                [const_1.TabsListAttrs.role]: { default: 'unknown' },
            },
            content: `${const_1.TabsNode.Tab}*`,
            group: 'block',
            parseDOM: [{ tag: 'div.yfm-tab-list' }],
            toDOM(node) {
                return ['div', node.attrs, 0];
            },
            selectable: false,
            allowSelection: false,
            complex: 'inner',
        },
    });
};
exports.getSpec = getSpec;
