"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useYfmEditor = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const react_use_1 = require("react-use");
const core_1 = require("../core");
function useYfmEditor(props) {
    const rerender = (0, react_use_1.useUpdate)();
    const changeRef = react_1.default.useRef(props.onChange);
    changeRef.current = props.onChange;
    const editor = react_1.default.useMemo(() => {
        return new core_1.YfmEditor(Object.assign(Object.assign({}, props), { onChange(e) {
                var _a;
                (_a = changeRef.current) === null || _a === void 0 ? void 0 : _a.call(changeRef, e);
                // need to re-render react view, based on editor state
                rerender();
            } }));
    }, [props.extensions, props.allowHTML, props.linkify, props.linkifyTlds]);
    // Commented out for support react@18 strict mode
    // React.useEffect(() => {
    //     return () => {
    //         editor.destroy();
    //     };
    // }, [editor]);
    return editor;
}
exports.useYfmEditor = useYfmEditor;
