"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarButton = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const isFunction_1 = tslib_1.__importDefault(require("lodash/isFunction"));
const uikit_1 = require("@gravity-ui/uikit");
const classname_1 = require("../classname");
const common_1 = require("../i18n/common");
const const_1 = require("./const");
const b = (0, classname_1.cn)('toolbar-button');
function ToolbarButton({ className, id, title, hotkey, editor, icon, disabledPopoverVisible = true, exec, focus, onClick, isActive, isEnable, }) {
    var _a;
    const active = isActive(editor);
    const enabled = isEnable(editor);
    const disabled = !active && !enabled;
    const buttonRef = (0, react_1.useRef)(null);
    const titleText = (0, isFunction_1.default)(title) ? title() : title;
    return (react_1.default.createElement(uikit_1.Popover, { content: (0, common_1.i18n)('toolbar_action_disabled'), disabled: !disabledPopoverVisible || !disabled, tooltipContentClassName: b('action-disabled-tooltip'), placement: ['bottom'] },
        react_1.default.createElement(uikit_1.ActionTooltip, { openDelay: const_1.ToolbarTooltipDelay.Open, closeDelay: const_1.ToolbarTooltipDelay.Close, title: titleText, hotkey: hotkey },
            react_1.default.createElement(uikit_1.Button, { ref: buttonRef, size: "m", selected: active, disabled: disabled, view: active ? 'normal' : 'flat', onClick: () => {
                    focus();
                    exec(editor);
                    onClick === null || onClick === void 0 ? void 0 : onClick(id);
                }, className: b(null, [className]), extraProps: { 'aria-label': titleText } },
                react_1.default.createElement(uikit_1.Icon, { data: icon.data, size: (_a = icon.size) !== null && _a !== void 0 ? _a : 16 })))));
}
exports.ToolbarButton = ToolbarButton;
