"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ToolbarButtonGroup = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const classname_1 = require("../classname");
const ToolbarButton_1 = require("./ToolbarButton");
const ToolbarListButton_1 = require("./ToolbarListButton");
const types_1 = require("./types");
const b = (0, classname_1.cn)('toolbar-group');
function ToolbarButtonGroup({ className, editor, data, focus, onClick, }) {
    return (react_1.default.createElement("div", { className: b(null, [className]) }, data.map((item) => {
        if (item.type === types_1.ToolbarDataType.SingleButton) {
            return (react_1.default.createElement(ToolbarButton_1.ToolbarButton, Object.assign({}, item, { key: item.id, editor: editor, focus: focus, onClick: onClick, className: b(item.type, { id: item.id }, [item.className]) })));
        }
        if (item.type === types_1.ToolbarDataType.ListButton) {
            return (react_1.default.createElement(ToolbarListButton_1.ToolbarListButton, Object.assign({}, item, { key: item.id, editor: editor, focus: focus, onClick: onClick, className: b(item.type, { id: item.id }, [item.className]) })));
        }
        if (item.type === types_1.ToolbarDataType.ReactComponent) {
            const Component = item.component;
            return (react_1.default.createElement(Component, { key: item.id, editor: editor, focus: focus, onClick: onClick, className: b(item.type, { id: item.id }, [item.className]) }));
        }
        if (item.type === types_1.ToolbarDataType.ReactNode) {
            return react_1.default.createElement(react_1.default.Fragment, { key: item.id }, item.content);
        }
        if (item.type === types_1.ToolbarDataType.ReactNodeFn) {
            return react_1.default.createElement(react_1.default.Fragment, { key: item.id }, item.content(editor));
        }
        return null;
    })));
}
exports.ToolbarButtonGroup = ToolbarButtonGroup;
