"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.wToolbarConfig = exports.wHiddenData = exports.wMathListConfig = exports.wMathBlockItemData = exports.wTabsItemData = exports.wMathInlineItemData = exports.wHruleItemData = exports.wCodeListConfig = exports.wCodeBlockItemData = exports.wCodeItemData = exports.wTableItemData = exports.wNoteItemData = exports.wCutItemData = exports.wQuoteItemData = exports.wCheckboxItemData = exports.wListsListConfig = exports.wHeadingListConfig = exports.wBiusGroupConfig = exports.wItalicItemData = exports.wBoldItemData = exports.wHistoryGroupConfig = void 0;
const menubar_1 = require("../../i18n/menubar");
const hints_1 = require("../../i18n/hints");
const types_1 = require("../types");
const shortcuts_1 = require("../../shortcuts");
const icons_1 = require("../../icons");
const action_names_1 = require("./action-names");
exports.wHistoryGroupConfig = [
    {
        id: action_names_1.ActionName.undo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'undo'),
        icon: icons_1.icons.undo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Undo),
        disabledPopoverVisible: true,
        exec: (e) => e.actions.undo.run(),
        isActive: (e) => e.actions.undo.isActive(),
        isEnable: (e) => e.actions.undo.isEnable(),
    },
    {
        id: action_names_1.ActionName.redo,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'redo'),
        icon: icons_1.icons.redo,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Redo),
        disabledPopoverVisible: true,
        exec: (e) => e.actions.redo.run(),
        isActive: (e) => e.actions.redo.isActive(),
        isEnable: (e) => e.actions.redo.isEnable(),
    },
];
/** Bold, Italic, Underline, Strike buttons group */
exports.wBoldItemData = {
    id: action_names_1.ActionName.bold,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'bold'),
    icon: icons_1.icons.bold,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Bold),
    exec: (e) => e.actions.bold.run(),
    isActive: (e) => e.actions.bold.isActive(),
    isEnable: (e) => e.actions.bold.isEnable(),
};
exports.wItalicItemData = {
    id: action_names_1.ActionName.italic,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'italic'),
    icon: icons_1.icons.italic,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Italic),
    exec: (e) => e.actions.italic.run(),
    isActive: (e) => e.actions.italic.isActive(),
    isEnable: (e) => e.actions.italic.isEnable(),
};
exports.wBiusGroupConfig = [
    exports.wBoldItemData,
    exports.wItalicItemData,
    {
        id: action_names_1.ActionName.underline,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'underline'),
        icon: icons_1.icons.underline,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Underline),
        exec: (e) => e.actions.underline.run(),
        isActive: (e) => e.actions.underline.isActive(),
        isEnable: (e) => e.actions.underline.isEnable(),
    },
    {
        id: action_names_1.ActionName.strike,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'strike'),
        icon: icons_1.icons.strikethrough,
        hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Strike),
        exec: (e) => e.actions.strike.run(),
        isActive: (e) => e.actions.strike.isActive(),
        isEnable: (e) => e.actions.strike.isEnable(),
    },
    {
        id: action_names_1.ActionName.mono,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'mono'),
        icon: icons_1.icons.mono,
        exec: (e) => e.actions.mono.run(),
        isActive: (e) => e.actions.mono.isActive(),
        isEnable: (e) => e.actions.mono.isEnable(),
    },
    {
        id: action_names_1.ActionName.mark,
        type: types_1.ToolbarDataType.SingleButton,
        title: menubar_1.i18n.bind(null, 'mark'),
        icon: icons_1.icons.mark,
        exec: (e) => e.actions.mark.run(),
        isActive: (e) => e.actions.mark.isActive(),
        isEnable: (e) => e.actions.mark.isEnable(),
    },
];
exports.wHeadingListConfig = {
    icon: icons_1.icons.headline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'heading'),
    data: [
        {
            id: action_names_1.ActionName.heading1,
            title: menubar_1.i18n.bind(null, 'heading1'),
            icon: icons_1.icons.h1,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading1),
            exec: (e) => e.actions.toH1.run(),
            isActive: (e) => e.actions.toH1.isActive(),
            isEnable: (e) => e.actions.toH1.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading2,
            title: menubar_1.i18n.bind(null, 'heading2'),
            icon: icons_1.icons.h2,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading2),
            exec: (e) => e.actions.toH2.run(),
            isActive: (e) => e.actions.toH2.isActive(),
            isEnable: (e) => e.actions.toH2.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading3,
            title: menubar_1.i18n.bind(null, 'heading3'),
            icon: icons_1.icons.h3,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading3),
            exec: (e) => e.actions.toH3.run(),
            isActive: (e) => e.actions.toH3.isActive(),
            isEnable: (e) => e.actions.toH3.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading4,
            title: menubar_1.i18n.bind(null, 'heading4'),
            icon: icons_1.icons.h4,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading4),
            exec: (e) => e.actions.toH4.run(),
            isActive: (e) => e.actions.toH4.isActive(),
            isEnable: (e) => e.actions.toH4.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading5,
            title: menubar_1.i18n.bind(null, 'heading5'),
            icon: icons_1.icons.h5,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading5),
            exec: (e) => e.actions.toH5.run(),
            isActive: (e) => e.actions.toH5.isActive(),
            isEnable: (e) => e.actions.toH5.isEnable(),
        },
        {
            id: action_names_1.ActionName.heading6,
            title: menubar_1.i18n.bind(null, 'heading6'),
            icon: icons_1.icons.h6,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Heading6),
            exec: (e) => e.actions.toH6.run(),
            isActive: (e) => e.actions.toH6.isActive(),
            isEnable: (e) => e.actions.toH6.isEnable(),
        },
    ],
};
exports.wListsListConfig = {
    icon: icons_1.icons.bulletList,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'list'),
    data: [
        {
            id: action_names_1.ActionName.bulletList,
            title: menubar_1.i18n.bind(null, 'ulist'),
            icon: icons_1.icons.bulletList,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.BulletList),
            exec: (e) => e.actions.toBulletList.run(),
            isActive: (e) => e.actions.toBulletList.isActive(),
            isEnable: (e) => e.actions.toBulletList.isEnable(),
        },
        {
            id: action_names_1.ActionName.orderedList,
            title: menubar_1.i18n.bind(null, 'olist'),
            icon: icons_1.icons.orderedList,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.OrderedList),
            exec: (e) => e.actions.toOrderedList.run(),
            isActive: (e) => e.actions.toOrderedList.isActive(),
            isEnable: (e) => e.actions.toOrderedList.isEnable(),
        },
        {
            id: action_names_1.ActionName.sinkListItem,
            title: menubar_1.i18n.bind(null, 'list__action_sink'),
            icon: icons_1.icons.sink,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.SinkListItem),
            disabledPopoverVisible: true,
            exec: (e) => e.actions.sinkListItem.run(),
            isActive: (e) => e.actions.sinkListItem.isActive(),
            isEnable: (e) => e.actions.sinkListItem.isEnable(),
        },
        {
            id: action_names_1.ActionName.liftListItem,
            title: menubar_1.i18n.bind(null, 'list__action_lift'),
            icon: icons_1.icons.lift,
            hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.LiftListItem),
            disabledPopoverVisible: true,
            exec: (e) => e.actions.liftListItem.run(),
            isActive: (e) => e.actions.liftListItem.isActive(),
            isEnable: (e) => e.actions.liftListItem.isEnable(),
        },
    ],
};
exports.wCheckboxItemData = {
    id: action_names_1.ActionName.checkbox,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'checkbox'),
    icon: icons_1.icons.checklist,
    exec: (e) => e.actions.addCheckbox.run(),
    isActive: (e) => e.actions.addCheckbox.isActive(),
    isEnable: (e) => e.actions.addCheckbox.isEnable(),
};
exports.wQuoteItemData = {
    id: action_names_1.ActionName.quote,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'quote'),
    icon: icons_1.icons.quote,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Quote),
    exec: (e) => e.actions.quote.run(),
    isActive: (e) => e.actions.quote.isActive(),
    isEnable: (e) => e.actions.quote.isEnable(),
};
exports.wCutItemData = {
    id: action_names_1.ActionName.yfm_cut,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'cut'),
    icon: icons_1.icons.cut,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Cut),
    exec: (e) => e.actions.toYfmCut.run(),
    isActive: (e) => e.actions.toYfmCut.isActive(),
    isEnable: (e) => e.actions.toYfmCut.isEnable(),
};
exports.wNoteItemData = {
    id: action_names_1.ActionName.yfm_note,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'note'),
    icon: icons_1.icons.note,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Note),
    exec: (e) => e.actions.toYfmNote.run(),
    isActive: (e) => e.actions.toYfmNote.isActive(),
    isEnable: (e) => e.actions.toYfmNote.isEnable(),
};
exports.wTableItemData = {
    id: action_names_1.ActionName.table,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'table'),
    icon: icons_1.icons.table,
    exec: (e) => e.actions.createYfmTable.run(),
    isActive: (e) => e.actions.createYfmTable.isActive(),
    isEnable: (e) => e.actions.createYfmTable.isEnable(),
};
exports.wCodeItemData = {
    id: action_names_1.ActionName.code_inline,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'code_inline'),
    icon: icons_1.icons.code,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.Code),
    exec: (e) => e.actions.code.run(),
    isActive: (e) => e.actions.code.isActive(),
    isEnable: (e) => e.actions.code.isEnable(),
};
exports.wCodeBlockItemData = {
    id: action_names_1.ActionName.code_block,
    title: menubar_1.i18n.bind(null, 'codeblock'),
    icon: icons_1.icons.codeBlock,
    hotkey: shortcuts_1.formatter.toView(shortcuts_1.Action.CodeBlock),
    exec: (e) => e.actions.toCodeBlock.run(),
    isActive: (e) => e.actions.toCodeBlock.isActive(),
    isEnable: (e) => e.actions.toCodeBlock.isEnable(),
};
exports.wCodeListConfig = {
    icon: icons_1.icons.code,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'code'),
    data: [exports.wCodeItemData, exports.wCodeBlockItemData],
};
exports.wHruleItemData = {
    id: action_names_1.ActionName.horizontalrule,
    title: menubar_1.i18n.bind(null, 'hrule'),
    icon: icons_1.icons.horizontalRule,
    exec: (e) => e.actions.hRule.run(),
    isActive: (e) => e.actions.hRule.isActive(),
    isEnable: (e) => e.actions.hRule.isEnable(),
};
exports.wMathInlineItemData = {
    id: action_names_1.ActionName.math_inline,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'math_inline'),
    icon: icons_1.icons.functionInline,
    hint: () => `${hints_1.i18n.bind(null, 'math_hint')()} ${hints_1.i18n.bind(null, 'math_hint_katex')()}`,
    exec: (e) => e.actions.addMathInline.run(),
    isActive: (e) => e.actions.addMathInline.isActive(),
    isEnable: (e) => e.actions.addMathInline.isEnable(),
};
exports.wTabsItemData = {
    id: action_names_1.ActionName.tabs,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'tabs'),
    icon: icons_1.icons.tabs,
    exec: (e) => e.actions.toYfmTabs.run(),
    isActive: (e) => e.actions.toYfmTabs.isActive(),
    isEnable: (e) => e.actions.toYfmTabs.isEnable(),
};
exports.wMathBlockItemData = {
    id: action_names_1.ActionName.math_block,
    type: types_1.ToolbarDataType.SingleButton,
    title: menubar_1.i18n.bind(null, 'math_block'),
    icon: icons_1.icons.functionBlock,
    hint: () => `${hints_1.i18n.bind(null, 'math_hint')()} ${hints_1.i18n.bind(null, 'math_hint_katex')()}`,
    exec: (e) => e.actions.toMathBlock.run(),
    isActive: (e) => e.actions.toMathBlock.isActive(),
    isEnable: (e) => e.actions.toMathBlock.isEnable(),
};
exports.wMathListConfig = {
    icon: icons_1.icons.functionInline,
    withArrow: true,
    title: menubar_1.i18n.bind(null, 'math'),
    data: [exports.wMathInlineItemData, exports.wMathBlockItemData],
};
exports.wHiddenData = [exports.wHruleItemData, exports.wTabsItemData];
/** prepared wysiwyg toolbar config */
exports.wToolbarConfig = [
    exports.wHistoryGroupConfig,
    exports.wBiusGroupConfig,
    [
        Object.assign({ id: 'heading', type: types_1.ToolbarDataType.ListButton }, exports.wHeadingListConfig),
        Object.assign({ id: 'list', type: types_1.ToolbarDataType.ListButton }, exports.wListsListConfig),
        exports.wNoteItemData,
        exports.wCutItemData,
        exports.wQuoteItemData,
        Object.assign({ id: 'code', type: types_1.ToolbarDataType.ListButton }, exports.wCodeListConfig),
        Object.assign({ id: 'math', type: types_1.ToolbarDataType.ListButton }, exports.wMathListConfig),
    ],
    [exports.wTableItemData, exports.wCheckboxItemData],
];
