/// <reference types="react" />
import { EditorState } from 'prosemirror-state';
import type { ExtensionAuto } from '../../../core';
import { EventEmitter } from '../../../utils/event-emitter';
import { Renderer, RendererItem, RenderStorage, RenderStorageEventMap, RenderStorageItem } from './types';
export type { RendererItem } from './types';
export { Renderer as ReactRendererComponent } from './react';
export type { RendererProps as ReactRendererComponentProps } from './react';
export declare function getReactRendererFromState(state: EditorState): ReactRenderer;
export declare type ReactRenderer = Renderer<React.ReactNode>;
export declare const ReactRendererExtension: ExtensionAuto<ReactRenderer>;
declare global {
    namespace YfmEditor {
        interface Context {
            reactrenderer: ReactRenderer;
        }
    }
}
declare type RenderFn = () => React.ReactNode;
export declare class ReactRenderStorage extends EventEmitter<RenderStorageEventMap> implements ReactRenderer, RenderStorage<React.ReactNode> {
    #private;
    private static Item;
    getItems(): readonly RenderStorageItem<React.ReactNode>[];
    createItem(idPrefix: string, render: RenderFn): RendererItem;
    removeItem(item: RendererItem): void;
    removeItem(id: string): void;
}
