import type { Action, ExtensionAuto } from '../../../core';
import { HeadingAction } from './const';
import { YfmHeadingSpecsOptions } from './YfmHeadingSpecs';
export { YfmHeadingAttr } from './const';
export declare type YfmHeadingOptions = YfmHeadingSpecsOptions & {
    h1Key?: string | null;
    h2Key?: string | null;
    h3Key?: string | null;
    h4Key?: string | null;
    h5Key?: string | null;
    h6Key?: string | null;
};
/** YfmHeading extension needs markdown-it-attrs plugin */
export declare const YfmHeading: ExtensionAuto<YfmHeadingOptions>;
declare global {
    namespace YfmEditor {
        interface Actions {
            [HeadingAction.ToH1]: Action;
            [HeadingAction.ToH2]: Action;
            [HeadingAction.ToH3]: Action;
            [HeadingAction.ToH4]: Action;
            [HeadingAction.ToH5]: Action;
            [HeadingAction.ToH6]: Action;
        }
    }
}
