import { CheckboxSpecs } from './Checkbox/CheckboxSpecs';
import { ColorSpecs } from './Color/ColorSpecs';
import { MathSpecs } from './Math/MathSpecs';
import { MonospaceSpecs } from './Monospace/MonospaceSpecs';
import { ImgSizeSpecs } from './ImgSize/ImgSizeSpecs';
import { VideoSpecs } from './Video/VideoSpecs';
import { YfmDistSpecs } from './YfmDist/YfmDistSpecs';
import { YfmCutSpecs } from './YfmCut/YfmCutSpecs';
import { YfmFileSpecs } from './YfmFile/YfmFileSpecs';
import { YfmHeadingSpecs } from './YfmHeading/YfmHeadingSpecs';
import { YfmNoteSpecs } from './YfmNote/YfmNoteSpecs';
import { YfmTableSpecs } from './YfmTable/YfmTableSpecs';
import { YfmTabsSpecs } from './YfmTabs/YfmTabsSpecs';
export * from './Checkbox/CheckboxSpecs';
export * from './Color/ColorSpecs';
export * from './ImgSize/ImgSizeSpecs';
export * from './Math/MathSpecs';
export * from './Monospace/MonospaceSpecs';
export * from './Video/VideoSpecs';
export * from './YfmDist/YfmDistSpecs';
export * from './YfmCut/YfmCutSpecs';
export * from './YfmFile/YfmFileSpecs';
export * from './YfmHeading/YfmHeadingSpecs';
export * from './YfmNote/YfmNoteSpecs';
export * from './YfmTable/YfmTableSpecs';
export * from './YfmTabs/YfmTabsSpecs';
export const YfmSpecsPreset = (builder, opts) => {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    builder
        .use(CheckboxSpecs, (_a = opts.checkbox) !== null && _a !== void 0 ? _a : {})
        .use(ColorSpecs, (_b = opts.color) !== null && _b !== void 0 ? _b : {})
        .use(ImgSizeSpecs, (_c = opts.imgSize) !== null && _c !== void 0 ? _c : {})
        .use(MathSpecs)
        .use(MonospaceSpecs)
        .use(VideoSpecs, (_d = opts.video) !== null && _d !== void 0 ? _d : {})
        .use(YfmDistSpecs)
        .use(YfmCutSpecs, (_e = opts.yfmCut) !== null && _e !== void 0 ? _e : {})
        .use(YfmNoteSpecs, (_f = opts.yfmNote) !== null && _f !== void 0 ? _f : {})
        .use(YfmFileSpecs)
        .use(YfmHeadingSpecs, (_g = opts.yfmHeading) !== null && _g !== void 0 ? _g : {})
        .use(YfmTableSpecs, (_h = opts.yfmTable) !== null && _h !== void 0 ? _h : {})
        .use(YfmTabsSpecs, (_j = opts.yfmTabs) !== null && _j !== void 0 ? _j : {});
};
