import React from 'react';
import type { NodeView, EditorView } from 'prosemirror-view';
import type { Node } from 'prosemirror-model';
import { ExtensionDeps, NodeViewConstructor, Serializer } from '../core';
declare type ReactNodeViewOptions<T> = {
    isInline?: boolean;
    reactNodeWrapperCn?: string;
    extensionOptions?: T;
};
export declare const ReactNodeStopEventCn = "prosemirror-stop-event";
export declare type ReactNodeViewProps<T extends object = {}> = {
    dom: HTMLElement;
    view: EditorView;
    updateAttributes: (attrs: object) => void;
    node: Node;
    getPos: () => number;
    serializer: Serializer;
    extensionOptions?: T;
};
export declare class ReactNodeView<T extends object = {}> implements NodeView {
    readonly dom: HTMLElement;
    node: Node;
    readonly view: EditorView;
    readonly serializer: Serializer;
    readonly renderItem: import("../extensions").RendererItem;
    readonly getPos: () => number;
    constructor(Component: React.FC<ReactNodeViewProps<T>>, opts: {
        node: Node;
        view: EditorView;
        getPos: () => number;
        serializer: Serializer;
        options?: ReactNodeViewOptions<T>;
    });
    update(node: Node): boolean;
    destroy(): void;
    ignoreMutation(): boolean;
    updateAttributes(attributes: {}): void;
    stopEvent(e: Event): boolean;
}
export declare const reactNodeViewFactory: <T extends object = {}>(Component: React.FC<ReactNodeViewProps<T>>, options?: ReactNodeViewOptions<T>) => (deps: ExtensionDeps) => NodeViewConstructor;
export {};
